//=============================================================================
// DeathTent.				Um.. well, orginally by Maniac
//=============================================================================
class DeathTent expands Pack6Pawns;

#exec MESH IMPORT MESH=Tentacle1 ANIVFILE=MODELS\tentcl_a.3D DATAFILE=MODELS\tentcl_d.3D X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=Tentacle1 X=00 Y=330 Z=00 YAW=64 ROLL=-64

#exec MESH SEQUENCE MESH=Tentacle1 SEQ=All    STARTFRAME=0   NUMFRAMES=156 RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Curl   STARTFRAME=0   NUMFRAMES=18  RATE=15 Group=Hiding
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Dead1  STARTFRAME=18  NUMFRAMES=25  RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Dead1Land STARTFRAME=43  NUMFRAMES=3 RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Dead2  STARTFRAME=46  NUMFRAMES=11  RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Hide   STARTFRAME=57  NUMFRAMES=1            Group=Hiding
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Move1  STARTFRAME=58  NUMFRAMES=10
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Move2  STARTFRAME=68  NUMFRAMES=10
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Shoot  STARTFRAME=78  NUMFRAMES=15  RATE=15  Group=Attack
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Smack  STARTFRAME=93  NUMFRAMES=30  Group=Attack
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Uncurl STARTFRAME=123 NUMFRAMES=18  RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Fighter  STARTFRAME=141 NUMFRAMES=1  RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=Waver  STARTFRAME=141 NUMFRAMES=15  RATE=15
#exec MESH SEQUENCE MESH=Tentacle1 SEQ=TakeHit STARTFRAME=132 NUMFRAMES=1 

#exec TEXTURE IMPORT NAME=JTentacle1 FILE=MODELS\Tentacle.PCX GROUP="Skins" 
#exec MESHMAP SCALE MESHMAP=Tentacle1 X=0.15 Y=0.15 Z=0.3
#exec MESHMAP SETTEXTURE MESHMAP=Tentacle1 NUM=1 TEXTURE=JTentacle1 TLOD=10

#exec MESH NOTIFY MESH=Tentacle1 SEQ=Dead1 TIME=0.96 FUNCTION=Drop
#exec MESH NOTIFY MESH=Tentacle1 SEQ=Smack TIME=0.6 FUNCTION=SmackTarget

#exec AUDIO IMPORT FILE="Sounds\Tentacle\injured1.WAV" NAME="injured1tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\injured2.WAV" NAME="injured2tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\yell1.WAV" NAME="yell1tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\yell2.WAV" NAME="yell2tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\waver1.WAV" NAME="waver1tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\splat2.WAV" NAME="splat2tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\death2a.WAV" NAME="death2tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\strike2.WAV" NAME="strike2tn" GROUP="Tentacle"
#exec AUDIO IMPORT FILE="Sounds\Tentacle\mebax.WAV" NAME="curltn" GROUP="Tentacle"

//-----------------------------------------------------------------------------
// Tentacle variables.

// Attack damage.
var() int WhipDamage; // Damage done by whipping.

var(Sounds) sound mebax;
var(Sounds)  sound whip;
var(Sounds) sound Smack;

var float Count,Counting;
var QueenDT Mommy;
var bool bMyBaby;
var int OwnChilds;
var bool bDestroying,bAllredyDestroyed;

//-----------------------------------------------------------------------------
// Tentacle functions.

function PostBeginPlay()
{
	Super.PostBeginPlay();
	bLeadTarget = bLeadTarget && (FRand() > 0.5);
}

function WhatToDoNext(name LikelyState, name LikelyLabel)
{
	bQuiet = false;
	GotoState('Waiting');
}
function Destroyed()
{
	local DeathTent DT;
	
	if( Mommy!=None && Mommy.Class!=None )
	{
		Mommy.NrOfChildren--;
		if( bMyBaby )
			Mommy.NrOfBabies--;
	}
	if( bDestroying )
	{
		ForEach AllActors(class'DeathTent',DT,Tag)
		{
			if( DT.Health>0 && !DT.IsInState('Teleporting') && !DT.bDestroying )
			{
				DT.bDestroying = True;
				DT.GoToState('Teleporting');
				Break;
			}
		}
	}
	Super.Destroyed();
}
function eAttitude AttitudeToCreature(Pawn Other)
{
	if ( Other.IsA('DeathTent') || Other.IsA('Tentacle') || Other.IsA('Barnacle') || Other.IsA('MirrorTent') )
		return ATTITUDE_Friendly;
	else if ( Other.IsA('ScriptedPawn') )
		return ATTITUDE_Hate;
	else
		return ATTITUDE_Ignore;
}
simulated function Tick(float DeltaTime)
{
	local DeathTent DT;
	local Vector SpawnPoint,V,HitLocation,HitNormal;

	if( Mommy!=None && Mommy.bDeleteMe )
		Mommy = None;
	if ( Count<=20 && Mommy!=None ) 
		Count += DeltaTime*(FRand()+0.5);
	if( Counting<4 )
		Counting+=DeltaTime;
	if ( ((Count>20 && Mommy.bDone) || (Count>1 && !Mommy.bDone)) && Mommy!=None && Mommy.NrOfChildren<30 && Mommy.Health>0 && (OwnChilds<3 || FRand()<0.2) )
	{
		SpawnPoint = Location;
		SpawnPoint.Z += Rand(1200)-600;
		SpawnPoint.X += Rand(1500)-750;
		if( SpawnPoint.X<=200 && SpawnPoint.X>=-200 )
			SpawnPoint.X=(Rand(2)*400)-200;
		SpawnPoint.Y += Rand(1500)-750;
		if( SpawnPoint.Y<=200 && SpawnPoint.Y>=-200 )
			SpawnPoint.Y=(Rand(2)*400)-200;
		V = SpawnPoint;
		V.Z += 1000;
		
		Trace(HitLocation,HitNormal,V,SpawnPoint,true);
		
		ForEach RadiusActors(class'DeathTent',DT,100,HitLocation)
		{
			if( DT!=Self )
			{
				Count=4; // Dont spawn if its going to spawn 2 close to another one
				Return;
			}
		}
		DT = Spawn(class'DeathTent',,,HitLocation);
		if( DT!=None )
		{
			Mommy.NrOfChildren++;
			OwnChilds++;
			DT.Mommy = Mommy;
			DT.Tag = Tag;
		}
		Count = 0;
	}
	if( Counting>=3 )
	{
		Counting=0;
		CheckVisibleEnemys();
	}
}
simulated function AddVelocity( vector NewVelocity )
{
	if (Physics == PHYS_Rotating)
		Velocity = vect(0,0,0);
	else
		Velocity += NewVelocity;
}
function bool SetEnemy( Pawn NewEnemy )
{
	local bool result;

	bCanWalk = true; //even though can't move, still acquire enemies
	result = DoSetEnemy(NewEnemy);
	bCanWalk = false;
	return result;
}
function bool DoSetEnemy(Pawn NewEnemy)
{
	if( NewEnemy.Health<=0 ) Return false;
	if( NewEnemy.IsA('DeathTent') || NewEnemy.IsA('FlockPawn') ) Return false;
	if( NewEnemy.IsA('Tentacle') || NewEnemy.IsA('MirrorTent') || NewEnemy.IsA('Barnacle') ) Return false;
	else if( NewEnemy.IsA('ScriptedPawn') )
	{
		if( Enemy!=None && Enemy!=NewEnemy )
			OldEnemy=Enemy;
		Enemy=NewEnemy;
		Target=NewEnemy;
	}
	else
	{
		if( Enemy!=None && Enemy!=NewEnemy )
			OldEnemy=Enemy;
		Enemy=NewEnemy;
		Target=NewEnemy;
	}
	if( IsInState('Waiting') || IsInState('Wandering') ) GoToState('Attacking');
	Return true;
}
function PreSetMovement()
{
	bCanJump = false;
	bCanWalk = false;
	bCanSwim = true;
	bCanFly = false;
	MinHitWall = -0.6;
	bCanOpenDoors = false;
	bCanDoSpecial = false;
}

function bool CanFireAtEnemy()
{
	local vector HitLocation, HitNormal, EnemyDir, projStart, EnemyUp;
	local actor HitActor;
	local float EnemyDist;
		
	EnemyDir = Enemy.Location - Location;
	EnemyDist = VSize(EnemyDir);
	EnemyUp = Enemy.CollisionHeight * vect(0,0,0.9);
	if ( EnemyDist > 300 )
	{
		EnemyDir = 300 * EnemyDir/EnemyDist;
		EnemyUp = 300 * EnemyUp/EnemyDist;
	}
		
	projStart = Location + CollisionHeight * vect(0,0,-1.2);
	
	HitActor = Trace(HitLocation, HitNormal, projStart + EnemyDir + EnemyUp, projStart, true);

	if ( (HitActor == None) || (HitActor == Enemy) 
		|| ((Pawn(HitActor) != None) && (AttitudeTo(Pawn(HitActor)) <= ATTITUDE_Ignore)) )
		return true;

	HitActor = Trace(HitLocation, HitNormal, projStart + EnemyDir, projStart, true);

	return ( (HitActor == None) || (HitActor == Enemy) 
			|| ((Pawn(HitActor) != None) && (AttitudeTo(Pawn(HitActor)) <= ATTITUDE_Ignore)) );
}

function SetMovementPhysics()
{
	if (Region.Zone.bWaterZone)
		SetPhysics(PHYS_Swimming);
	else
		SetPhysics(PHYS_Rotating); 
}

function Drop()
{
	//implemented in TentacleCarcass
}

singular function Falling()
{
	SetMovementPhysics();
}

function PlayWaiting()
{
	TweenAnim('Hide', 5.0);
}

function PlayPatrolStop()
{
	TweenAnim('Hide', 5.0);
}

function PlayWaitingAmbush()
{
	TweenAnim('Hide', 5.0);
}

function PlayChallenge()
{
	if ( GetAnimGroup(AnimSequence) == 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Uncurl', 0.6, 0.2);
	}
	else
		PlayAnim('Waver', 1.0, 0.1);
}

function TweenToFighter(float tweentime)
{
	if ( GetAnimGroup(AnimSequence) == 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Uncurl', 0.6, 0.2);
	}
	else
		TweenAnim('Waver', tweentime);
}

function TweenToRunning(float tweentime)
{
	if ( GetAnimGroup(AnimSequence) == 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Uncurl', 0.6, 0.2);
	}
	else if ( (AnimSequence != 'Move2') || !bAnimLoop )
		TweenAnim('Move2', tweentime);
}

function TweenToWalking(float tweentime)
{
	if ( GetAnimGroup(AnimSequence) == 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Uncurl', 0.6, 0.2);
	}
	else if ( (AnimSequence != 'Move1') || !bAnimLoop )
		TweenAnim('Move1', tweentime);
}

function TweenToWaiting(float tweentime)
{
	if ( GetAnimGroup(AnimSequence) != 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Curl', 0.6, 0.2);
	}
}

function TweenToPatrolStop(float tweentime)
{
	if ( GetAnimGroup(AnimSequence) == 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Uncurl', 0.6, 0.2);
	}
	else TweenAnim('Waver', tweentime);
}

function PlayRunning()
{
	LoopAnim('Move2', 1.0,, 0.4);
}

function PlayWalking()
{
	LoopAnim('Move1', 1.0,, 0.4);
}

function PlayThreatening()
{
	if ( FRand() < 0.8 )
		PlayAnim('Waver', 0.4);
	else
		PlayAnim('Smack', 0.4);
}

function PlayTurning()
{
	if ( GetAnimGroup(AnimSequence) == 'Hiding')
	{
		PlaySound(Mebax, SLOT_Interact);
		PlayAnim('Uncurl', 0.6, 0.2);
	}
	else
		LoopAnim('Waver');
}

function PlayDying(name DamageType, vector HitLocation)
{
	PlaySound(Die, SLOT_Talk, 3 * TransientSoundVolume);
	if ( Velocity.Z > 200 )
		PlayAnim('Dead2', 0.7, 0.1);
	else
	{
		PlayAnim('Dead1', 0.7, 0.1);
		SetPhysics(PHYS_None);
	}
}

function PlayTakeHit(float tweentime, vector HitLoc, int Damage)
{
	TweenAnim('TakeHit', tweentime);
}

function TweenToFalling()
{
	TweenAnim('Waver', 0.2);
}

function PlayInAir()
{
	LoopAnim('Waver');
}

function PlayLanded(float impactVel)
{
	PlayAnim('Waver');
}


function PlayVictoryDance()
{
	PlaySound(whip, SLOT_Interact);
	PlayAnim('Smack', 0.6, 0.1);
}
	
function PlayMeleeAttack()
{
	PlaySound(whip, SLOT_Interact);
	PlayAnim('Smack');
}

function SmackTarget()
{
	if ( MeleeDamageTarget(WhipDamage, (WhipDamage * 1000 * Normal(Target.Location - Location))) )
		PlaySound(Smack, SLOT_Interact);		
}

function PlayRangedAttack()
{
	local vector projStart;

	MakeNoise(1.0); 
	projStart = Location + CollisionHeight * vect(0,0,-1.2);
	spawn(RangedProjectile ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, 900, bLeadTarget, bWarnTarget));
	PlayAnim('Shoot');
}


state Attacking
{
ignores SeePlayer, HearNoise, Bump, HitWall;

	function ChooseAttackMode()
	{
		if (Physics == PHYS_Swimming)
		{
			Super.ChooseAttackMode();
			return;
		}
			
		if ((Enemy == None) || (Enemy.Health <= 0))
		{
			if ((OldEnemy != None) && (OldEnemy.Health > 0)) 
				{
				Enemy = OldEnemy;
				OldEnemy = None;
				}
			else
			{
				 GotoState('Waiting');
				 return;
			}
		}
			
		if (!LineOfSightTo(Enemy))
			GotoState('StakeOut');
		else
			GotoState('RangedAttack');
	}
}

state StakeOut
{
ignores EnemyNotVisible; 

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if (NextState == 'TakeHit')
		{
			NextState = 'Attacking';
			NextLabel = 'Begin';
			GotoState('TakeHit'); 
		}
	}

Begin:
	PlayChallenge();
	TurnTo(LastSeenPos);
HangOut:
	if ( bHasRangedAttack && bClearShot && (FRand() < 0.5) && (VSize(Enemy.Location - LastSeenPos) < 100) && CanStakeOut() )
		PlayRangedAttack();
	FinishAnim();
	PlayChallenge();
	Sleep(1 + FRand());
	if ( FRand() < 0.1 )
		GotoState('Waiting');
	else
		LoopAnim('Waver');
	Goto('HangOut');
}

state Acquisition
{
 
PlayOut:
	FinishAnim();
		
Begin:
	PlayTurning();
	FinishAnim();
	GotoState('Attacking');
}
State Teleporting
{
ignores TakeDamage, SeePlayer, EnemyNotVisible, HearNoise, KilledBy, Bump, HitWall, HeadZoneChange, FootZoneChange, ZoneChange, Falling, WarnTarget, Died;

	function Tick(float DeltaTime)
	{
		local int NewFatness; 
		local rotator EnemyRot;

		if ( Style == STY_Translucent )
		{
			ScaleGlow -= 3 * DeltaTime;
			if ( ScaleGlow < 0.3 )
			{
				PlaySound(sound'Teleport1', SLOT_Interface);
				bAllredyDestroyed = True;
				Destroy();
			}
			return;
		}
		else
		{
			NewFatness = fatness - 100 * DeltaTime;
			if ( NewFatness < 80 )
			{
				bUnlit = true;
				ScaleGlow = 2.0;
				Style = STY_Translucent;
			}
		}

		fatness = Clamp(NewFatness, 0, 255);
	}
	function BeginState()
	{
		Acceleration = Vect(0,0,0);
	}
	function EndState()
	{
		if( !bAllredyDestroyed )
		{
			bAllredyDestroyed = True;
			Destroy();
		}
	}
}

defaultproperties
{
     WhipDamage=666
     mebax=Sound'UnrealShare.Tentacle.curltn'
     Whip=Sound'UnrealShare.Tentacle.strike2tn'
     Smack=Sound'UnrealShare.Tentacle.splat2tn'
     CarcassType=Class'UnrealShare.TentacleCarcass'
     TimeBetweenAttacks=0.100000
     Aggressiveness=10.000000
     RefireRate=0.100000
     bHasRangedAttack=True
     bMovingRangedAttack=True
     bLeadTarget=False
     bWarnTarget=False
     RangedProjectile=Class'Pack6.DTBolt'
     ProjectileSpeed=8000.000000
     Acquire=Sound'UnrealShare.Tentacle.yell1tn'
     Fear=Sound'UnrealShare.Tentacle.injured2tn'
     Roam=Sound'UnrealShare.Tentacle.waver1tn'
     Threaten=Sound'UnrealShare.Tentacle.yell2tn'
     bCanStrafe=True
     MeleeRange=40.000000
     SightRadius=50000.000000
     HearingThreshold=0.010000
     Health=80
     Skill=9.000000
     HitSound1=Sound'UnrealShare.Tentacle.injured1tn'
     HitSound2=Sound'UnrealShare.Tentacle.injured2tn'
     Land=Sound'UnrealShare.Tentacle.splat2tn'
     Die=Sound'UnrealShare.Tentacle.death2tn'
     MenuName="Death Tentacle"
     DrawType=DT_Mesh
     Texture=Texture'UnrealShare.Effects.Arc2'
     Mesh=LodMesh'UnrealShare.Tentacle1'
     bMeshEnviroMap=True
     CollisionRadius=28.000000
     CollisionHeight=36.000000
}
